/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package html.shared.points;

import java.awt.Point;
import javax.swing.JOptionPane;

/**
 *
 * @author Paul Long
 * 
 * Points helper class
 * Used in drawing triangles
 */
public class Points
{
    
    public static Point RotatePoint(Point pPoint, Point pOrigin, int angle) {
        JOptionPane.showMessageDialog(null, angle);
        int x = (int)(pOrigin.getX()+ (Math.cos(angle / 180 * Math.PI) * (pPoint.getX()- pOrigin.getX()) - Math.sin(angle / 180 * Math.PI) * (pPoint.getY() - pOrigin.getY())));
        int y = (int)(pOrigin.getY() + (Math.sin(angle / 180 * Math.PI) * (pPoint.getX()- pOrigin.getX()) + Math.cos(angle / 180 * Math.PI) * (pPoint.getY() - pOrigin.getY())));
        return new Point(x, y);
    }

    public static Point MaxDistanceEndPoint(Point startPoint, Point proposedEndPoint, int maxDistance)
    {
        double ΔX = proposedEndPoint.getX() - startPoint.getX();
        double ΔY = proposedEndPoint.getY() - startPoint.getY();
        double distance = Math.sqrt((ΔX * ΔX) + (ΔY * ΔY));
        
        if (distance != maxDistance)
        {
            double distanceRatio = maxDistance / distance;
            return new Point((int)(startPoint.getX() + (ΔX * distanceRatio)), (int)(startPoint.getY() + (ΔY * distanceRatio)));
        }
        return proposedEndPoint;
    }    

}
