/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package html.shared.rounding;

/**
 *
 * @author Paul Long
 * 
 * Rounding helper class
 * Used in html output
 */
public class Rounding
{
    public static int fixDecimal(float f) {
        float i = f % 1;
        return (int)((i > 0.5) ? Math.ceil(f) : Math.floor(f));
    }

    public static String display(float f, boolean all, int cbIndex, int places)
    {
        if (all)
        {
            return String.valueOf(f);
        }
        else
        {
            if (cbIndex == 0) //dp
            {
                return DecimalPlaces(f, places);               
            }
            else //sf
            {
                return SignificantFigures(f, places);                
            }
        }
    }

    public static String SignificantFigures(float input, int sf)
    {
        return String.format("%." + sf + "G", input);
    }

    public static String DecimalPlaces(float input, int p)
    {
        return String.format("%." + p + "f", input);
    }

}
